package vgpu

import (
	"context"
	"encoding/json"
	"net/http"

	"repository.basistech.ru/BASIS/decort-golang-sdk/internal/validators"
)

// ListRequest struct to get list of VGPU
type ListRequest struct {
	// Find by id
	// Required: false
	ByID uint64 `url:"by_id,omitempty" json:"by_id,omitempty"`

	// Find by vgpu status
	// Required: false
	Status string `url:"status,omitempty" json:"status,omitempty"`

	// Find by mode
	// Required: false
	SplitMode string `url:"split_mode,omitempty" json:"split_mode,omitempty"`

	// Find by id node
	// Required: false
	NodeID uint64 `url:"node_id,omitempty" json:"node_id,omitempty"`

	// Find by account id
	// Required: false
	AccountID uint64 `url:"account_id,omitempty" json:"account_id,omitempty"`

	// Find by compute id
	// Required: false
	ComputeID uint64 `url:"compute_id,omitempty" json:"compute_id,omitempty"`

	// Find by pgpu id
	// Required: false
	PGPUID uint64 `url:"pgpu_id,omitempty" json:"pgpu_id,omitempty"`

	// Sort by one of supported fields, format +|-(field)
	// Required: false
	SortBy string `url:"sort_by,omitempty" json:"sort_by,omitempty" validate:"omitempty,sortBy"`

	// Page number
	// Required: false
	Page uint64 `url:"page,omitempty" json:"page,omitempty"`

	// Page size
	// Required: false
	Size uint64 `url:"size,omitempty" json:"size,omitempty"`
}

// List gets list of all VGPU as a ListVGPU struct
func (v VGPU) List(ctx context.Context, req ListRequest) (*ListVGPU, error) {

	res, err := v.ListRaw(ctx, req)
	if err != nil {
		return nil, err
	}

	list := ListVGPU{}

	err = json.Unmarshal(res, &list)
	if err != nil {
		return nil, err
	}

	return &list, nil
}

// ListRaw gets list of all VGPU as an array of bytes
func (v VGPU) ListRaw(ctx context.Context, req ListRequest) ([]byte, error) {

	err := validators.ValidateRequest(req)
	if err != nil {
		return nil, validators.ValidationErrors(validators.GetErrors(err))
	}

	url := "/cloudapi/vgpu/list"

	res, err := v.client.DecortApiCall(ctx, http.MethodGet, url, req)
	return res, err
}
